#!/bin/sh

# Try to log a hostname on the DHCP server
local REQ_HOSTNAME="$(hostname)"
if [ "${REQ_HOSTNAME}" = "(none)" -o "${REQ_HOSTNAME}" = '?' ]; then
   unset REQ_HOSTNAME
else
   REQ_HOSTNAME="-x hostname:${REQ_HOSTNAME}"
fi

# Never stop trying to get lease
local DHCPC_RETRIES=999999999
local DHCPC_TIMEOUT=5

## Perform network configuration in a background process to speedup boot.
(  ifconfig eth0 # debug output only
   echo "Hostname: $(hostname)."
   udhcpc -i eth0:dhcp -f -T ${DHCPC_TIMEOUT} -t ${DHCPC_RETRIES} $REQ_HOSTNAME -s /usr/libexec/udhcpc.sh
) >/var/run/udhcpc.log 2>&1 </dev/null &

exit 0
                                                         
