#! /bin/sh
# Configure alias address for use by weather module

WM_INTERFACE="eth0"
WM_INTERFACE_ALIAS="eth0:weather"
WM_ARP_TIMEOUT=5
WM_NETMASK="255.255.0.0"
WM_BASE_ADDRESS_16="172.22."

IP_ADDR=`/sbin/ifconfig ${WM_INTERFACE_ALIAS} | grep 'inet addr:' | cut -d: -f2 | awk '{ print $1}'`
IP_ADDR=`echo ${IP_ADDR} | awk -F"\." ' $1 <= 255 && $2 <= 255 && $3 <= 255 && $4 <= 255 '`

if [ -n "${IP_ADDR}" ]; then
	echo Already configured        
	exit 0
fi

IP_ADDR=`/sbin/ifconfig ${WM_INTERFACE} | grep 'inet addr:' | cut -d: -f2 | awk '{ print $1}'`
IP_ADDR=`echo ${IP_ADDR} | awk -F"\." ' $1 <= 255 && $2 <= 255 && $3 < 255 && $4 <= 255 '`	
if [ -n "${IP_ADDR}" ]; then
	IP_ADDR_0=`echo ${IP_ADDR} | cut -d. -f1`
	IP_ADDR_1=`echo ${IP_ADDR} | cut -d. -f2`
	IP_ADDR_2=`echo ${IP_ADDR} | cut -d. -f3`
	IP_ADDR_3=`echo ${IP_ADDR} | cut -d. -f4`

	TMPVAL=${IP_ADDR_3}

	while [ 1 ]
	do
		# Weather module uses 253 and 254
		if [ ${TMPVAL} -ge 253 ]; then
			TMPVAL=1                
		fi

		TEST_IP=${WM_BASE_ADDRESS_16}                
		if [ ${IP_ADDR_0} -eq 169 ]; then
			# zeroconf					
			TEST_IP=${TEST_IP}${IP_ADDR_2}\.${TMPVAL}					
		else
			# DHCP just use bottom 8 bits
			TEST_IP=${TEST_IP}255\.${TMPVAL}
		fi

		/usr/bin/arping -D -w ${WM_ARP_TIMEOUT} ${TEST_IP}
		RET=$?						
		if [ "${RET}" -eq 0 ]; then
			/sbin/ifconfig ${WM_INTERFACE_ALIAS} ${TEST_IP} netmask ${WM_NETMASK}
			exit 0	
		fi

		# increment address and try again
		TMPVAL=`expr ${TMPVAL} + 1`

		if [ $TMPVAL -eq ${IP_ADDR_3} ]; then
			# full circle bail
			exit 1
		fi						 
	done
fi

