#!/bin/sh

#set -e -x

echo "$(basename $0): $1" # debug
[ -n "$broadcast" ] && BROADCAST="broadcast $broadcast"
[ -n "$subnet" ] && NETMASK="netmask $subnet"

# only for use as a "zcip" callback script
if [ "x$interface" = x ]
then
	exit 1
fi

# zcip should start on boot/resume and various media changes
case "$1" in
init)
	# for now, zcip requires the link to be already up,
	# and it drops links when they go down.  that isn't
	# the most robust model...
        /sbin/ifconfig $interface up
	exit 0
	;;

config)
	[ "x$ip" = x ] && exit 1

	/sbin/ifconfig $interface $ip $BROADCAST $NETMASK

	if [ -x /etc/static-routes ]; then
		echo "/etc/static-routes+"
		/etc/static-routes
		echo "/etc/static-routes-"
	fi

	if [ -x /usr/libexec/weather-module.sh ]; then
		echo "/usr/libexec/weather-module.sh+"
		/usr/libexec/weather-module.sh
		echo "/usr/libexec/weather-module.sh-"
	fi

	if [ -x /etc/rc.d/launch-dhcpc.sh ]; then
		echo "/etc/rc.d/launch-dhcpc.sh+"
		/etc/rc.d/launch-dhcpc.sh
		echo "/etc/rc.d/launch-dhcpc.sh-"
	fi

	exit 0
	;;

deconfig)
	[ "x$ip" = x ] && exit 1

	exec ip address del dev $interface local $ip
	;;
esac
exit 1
