#!/bin/sh

# POST upload format:
# -----------------------------29995809218093749221856446032^M
# Content-Disposition: form-data; name="file1"; filename="..."^M
# Content-Type: application/octet-stream^M
# ^M    <--------- headers end with empty line
# file contents
# file contents
# file contents
# ^M    <--------- extra empty line
# -----------------------------29995809218093749221856446032--^M

# Beware: bashism $'\r' is used to handle ^M

file=/tmp/$$-$RANDOM

# CGI output must start with at least empty line (or headers)
printf '\r\n'
  cat <<EOF
<html>
<head>
<title>AP70 / AP80 Software Update Status</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
</head>
<body>
EOF

IFS=$'\r'
read -r delim_line

IFS=''
delim_line="${delim_line}--"$'\r'

read -r line
filename=$(echo $line | sed 's/^.*filename=//' | sed 's/\"//g' | sed 's/.$//')
fileext=${filename##*.}

while read -r line; do
    test "$line" = '' && break
    test "$line" = $'\r' && break
done

# Note: This will result in junk at end of line (see format above)
cat > $file

# Get the line count
LINES=$(wc -l $file | cut -d ' ' -f 1)

# Remove the last line
head -$((LINES - 1)) $file >$file.1

# Copy eveything but the last line to a temp file
head -$((LINES - 2)) $file.1 >$file.2

# Copy the new last line but remove trailing \r\n
tail -1 $file.1 | tr -d '\r\n' >$file.3
cat $file.2 $file.3 > $file.4
cp $file.4 $file

if [ "$fileext" = "usr" ]; then

   filepath="/home/nos/NOS/userdata/transfer/$filename"
   filepathtmp="/home/nos/NOS/userdata/transfer/tmp.usr"

   # first move to destination directory but using a tmp name (will be ignored by NOSApp)
   mv $file $filepathtmp

   # finally just rename to avoid a problem with the QFileSystemWatcher
   mv $filepathtmp $filepath

   cat <<EOF
<h1>Upload Successful</h1>
The uploaded file is a USR file.<br /><br />
File name = $filename<br />
File type = $fileext<br /><br />
EOF

   fi
else

   rm $file

   cat <<EOF
<h1>Upload Successful</h1>
File name = $filename<br />
File type = $fileext<br /><br />
This file was not an updater file.<br />
EOF

fi

cat <<EOF
</body>
</html>
EOF


exit 0
